-- frmSettings.lua
-- written by Habna

--v IMPORT SECTION v--
write = Turbine.Shell.WriteLine;
--^ IMPORT SECTION ^--
--v GLOBAL VARIABLE SECTION v--
--freeslots = 0; --> ** Global Variable to get the number of free slots **
--backpackSize = self; --> ** Global variable to get the number of items in all bags **
InitXPos, InitYPos = 17,33; --> ** Initial X & Y position of the first Item in the HugeBag **
edgePadding = 15; --> ** HugeBag initial edgePadding value **
Version = "1.0.3"; --> ** HugeBag current version **
StartVisible = true; --> ** Initial value to determine if HugeBag start visible or not **
ShowSlotsInfo = true; --> ** Initial value to determine if slots informations are shown are not in title **
WinWidth, WinHeight = 460,300; --> ** HugeBag initial size **
WinLocX, WinLocY = self, self; --> ** HugeBag initial location **
LockPosition, LockSize = false, false;
--settings = {}; --> ** HugeBag array for settings **
LockLabel = self;
HideWEsc = false; --> ** Initial value to determine if HugeBag hide when 'esc' key is press **
DefaultOpacity = 1; --> ** Initial opacity **

frmSettings = class( Turbine.UI.Lotro.Window );
--^ GLOBAL VARIABLE SECTION ^--

function frmSettings:Constructor()
	--v SETTINGS SECTION v--
	Turbine.UI.Lotro.Window.Constructor( self )
	green = Turbine.UI.Color( 0, 0.77, 0 );
	white = Turbine.UI.Color( 1, 1, 1 );
    
	LoadSettings();
	self:SetVisible( StartVisible );

	-- **v Set backcolor, position, size and text of the window v**
	self:SetSize( 350, 300 );
	self:SetPosition( WinLocX, WinLocY );
	self:SetText( "HugeBag Current Settings" );
	self:SetBackColor( Turbine.UI.Color() )
	-- **^
	--**v Startup visibility Label v**
	local label1q = Turbine.UI.Label();
	label1q:SetParent( self );
	label1q:SetText( "X" );
	label1q:SetPosition( 4, 275 );
	label1q:SetSize(20, 20 );
	label1q:SetBackColor( Turbine.UI.Color( 1, 0.2, 0.2, 0.2 ) );
	label1q:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	label1q:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	--label1q:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	--**^
	--**v Startup visibility Label v**
	local label1q = Turbine.UI.Label();
	label1q:SetParent( self );
	label1q:SetText( "Startup visibility:" );
	label1q:SetPosition( 15, 35 );
	label1q:SetSize(135, 25 );
	--label1q:SetBackColor( Turbine.UI.Color( 1, 0.2, 0.2, 0.2 ) );
	label1q:SetForeColor( white );
	label1q:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	label1q:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	--**^
	--**v Startup visibility answer Label v**
	local label1a = Turbine.UI.Label();
	label1a:SetParent( self );
	if ( StartVisible ) then
		label1a:SetText( "will start visible" );
	else
		label1a:SetText( "will start hidden" );
	end
	label1a:SetPosition( 155, 35 );
	label1a:SetSize(135, 25 );
	--label1a:SetBackColor( Turbine.UI.Color( 1, 0.2, 0.2, 0.2 ) );
	label1a:SetForeColor( green );
	label1a:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	label1a:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	--**^
	-- **v To create a new button v**
	local buttonClose = Turbine.UI.Lotro.Button();
	buttonClose:SetParent( self );
	buttonClose:SetPosition( 245, 267 );
	buttonClose:SetSize( 75, 150 );
	buttonClose:SetText( "Close" );
	buttonClose:SetVisible( true );
	-- **^
	--^ SETTINGS SECTION ^--
	--v EVENT HANDLERS SECTION v--
	--**v Window event handlers v**
	-- **v Set the opacity when the mouse enter the window v**
	self.MouseEnter = function( sender, args )
		sender:SetOpacity( 1.0 );
	end
	-- **^
	-- **v Set the opacity when the mouse leave the window v**
	self.MouseLeave = function( sender, args )
		sender:SetOpacity( 1.0 );
	end
	-- **^
	-- **v Do stuff before closing the window v**
	self.Closing = function( sender, args )
		
	end
	-- **^
	-- **v Position changed event v**
	self.PositionChanged = function(args)
		
	end
	-- **^
	-- **v Detecting key press event v**
	self.KeyDown = function( sender, args )
	
	end
	-- **^
	-- **v Windows mouse down event v**
	self.MouseDown = function( sender, args )
		
	end
	-- **^
	-- **v Windows mouse up event v**
	self.MouseUp = function( sender, args )
		
	end
	-- **^
	-- **v Windows mouse move event v**
	self.MouseMove = function( sender, args )
		
	end
	-- **^
	-- **v Windows sizechanged event v**
	self.SizeChanged = function( sender, args )
		
	end
	-- **^
	--**^ Window event handlers ^**
	--**v Button event handlers v**
	-- **v Button click event v**
	buttonClose.Click = function(sender, args)
		write( "click" );
	end
	-- **^
	--**^ Button event handlers ^**
	--^ EVENT HANDLERS SECTION ^--
end
-- **^
--v FUNCTIONS/METHODS SECTION v--
-- **v Load settings v**
function LoadSettings( sender )
	settings = {};
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagSettings" );
	
	-- **v no setting found, so save it v**
	if settings == nil then
		WinLocX = Turbine.UI.Display.GetWidth() - edgePadding - WinWidth
		WinLocY = Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55
		SaveSettings()
	end
	-- **^
	-- **v Load Settings v**
	WinLocX = settings.X;
	WinLocY = settings.Y;
	WinWidth = settings.Width;
	WinHeight = settings.Height;
	HideWEsc = settings.HideWEsc;
	StartVisible = settings.StartVisible;
	ShowSlotsInfo = settings.ShowSlotsInfo;
	LockPosition = settings.LockPosition;
	LockSize = settings.LockSize;
	-- **^
	-- **v Check version so settings can be updated (if a user used an old version before the last release)
	if ( settings.Version ~= Version ) then
		local Updatedsettings = {};

		if settings.StartVisible == nil then
			Updatedsettings.StartVisible = true;
		else
			Updatedsettings.StartVisible = StartVisible;
		end
		if settings.ShowSlotsInfo == nil then
			Updatedsettings.ShowSlotsInfo = true;
		else
			Updatedsettings.ShowSlotsInfo = ShowSlotsInfo;
		end

		Updatedsettings.X = WinLocX;
		Updatedsettings.Y = WinLocY;
		Updatedsettings.Width = WinWidth;
		Updatedsettings.Height = WinHeight;

		if settings.HideWEsc == nil then
			Updatedsettings.HideWEsc = false;
		else
			Updatedsettings.HideWEsc = HideWEsc;
		end
		if settings.LockPosition == nil then
			Updatedsettings.LockPosition = false;
		else
			Updatedsettings.LockPosition = LockPosition;
		end
		if settings.LockSize == nil then
			Updatedsettings.LockSize = false;
		else
			Updatedsettings.LockSize = LockSize;
		end

		Updatedsettings.Version = Version;
		Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagSettings", Updatedsettings );
	end
	-- **^
end
-- **^
-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;
	settings.StartVisible = StartVisible;
	settings.ShowSlotsInfo = ShowSlotsInfo;
	settings.X = WinLocX; --Turbine.UI.Display.GetWidth() - edgePadding - self:GetWidth()
	settings.Y = WinLocY; --Turbine.UI.Display.GetHeight() - edgePadding - self:GetHeight() - 55
	settings.Width = WinWidth; --frmMain:GetWidth();
	settings.Height = WinHeight; --frmMain:GetHeight();
	settings.HideWEsc = HideWEsc;
	settings.LockPosition = LockPosition;
	settings.LockSize = LockSize;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagSettings", settings );
end
-- **^
-- **v Reset Location and Size Settings v**
function ResetLSSettings()
	WinWidth, WinHeight = 460, 300;
	frmMain:SetSize( WinWidth, WinHeight );
	frmMain:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = frmMain:GetPosition()
	SaveSettings()
	frmMain:SetVisible( true );
	frmMain:PerformLayout()
	Turbine.Shell.WriteLine( "HugeBag: My location and size was set back to default" );
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	StartVisible = true;
	ShowSlotsInfo = true;
	HideWEsc = false;
	LockPosition = false;
	LockSize = false;
	WinWidth, WinHeight = 460, 300;
	frmMain:SetSize( WinWidth, WinHeight );
	frmMain:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = frmMain:GetPosition()
	SaveSettings()
	frmMain:SetVisible( true );
	frmMain:PerformLayout()
	Turbine.Shell.WriteLine( "HugeBag: All my settings was set back to default" );
end
-- **^
--^ FUNCTIONS/METHODS SECTION ^--